var NavItem, NavItemLink, RESERVED_PROPS, React, Router, isLeftClick, isModifiedEvent, makeHref, withoutProperties;

React = require('react');

Router = require('react-router');

NavItem = require('react-bootstrap/NavItem');

withoutProperties = require('react-router/modules/helpers/withoutProperties');

makeHref = require('react-router/modules/helpers/makeHref');

isLeftClick = function(event) {
  return event.button === 0;
};

isModifiedEvent = function(event) {
  return !!(event.metaKey || event.altKey || event.ctrlKey || event.shiftKey);
};

RESERVED_PROPS = {
  to: true,
  className: true,
  activeClassName: true,
  query: true,
  children: true,
  active: true,
  activeHref: true,
  activeKey: true,
  key: true,
  navItem: true,
  onSelect: true,
  ref: true
};

NavItemLink = React.createClass({
  displayName: 'NavItemLink',
  mixins: [Router.ActiveState],
  statics: {
    getUnreservedProps: function(props) {
      return withoutProperties(props, RESERVED_PROPS);
    }
  },
  propTypes: {
    to: React.PropTypes.string.isRequired,
    query: React.PropTypes.object
  },
  getInitialState: function() {
    return {
      isActive: false
    };
  },
  updateActiveState: function() {
    return this.setState({
      isActive: NavItemLink.isActive(this.props.to, this.props.params, this.props.query)
    });
  },
  getParams: function() {
    return NavItemLink.getUnreservedProps(this.props);
  },
  getHref: function() {
    return makeHref(this.props.to, this.getParams(), this.props.query);
  },
  componentWillReceiveProps: function(nextProps) {
    var params;
    params = NavItemLink.getUnreservedProps(nextProps);
    return this.setState({
      isActive: NavItemLink.isActive(nextProps.to, params, nextProps.query)
    });
  },
  updateActiveState: function() {
    return this.setState({
      isActive: NavItemLink.isActive(this.props.to, this.getParams(), this.props.query)
    });
  },
  handleClick: function(event) {
    if (isModifiedEvent(event) || !isLeftClick(event)) {
      return;
    }
    event.preventDefault();
    return Router.transitionTo(this.props.to, this.getParams(), this.props.query);
  },
  render: function() {
    return this.transferPropsTo(NavItem({
      "active": this.state.isActive,
      "onClick": this.handleClick
    }, this.props.children));
  }
});

module.exports = NavItemLink;
